/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT6.dat, Mon Sep  3 09:42:10 2012
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000346 (838)
 *     Revision         0x01
 *     Checksum         0xBA
 *     OEM ID           "Sony"
 *     OEM Table ID     "VAIO"
 *     OEM Revision     0x20120517 (538051863)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT6.aml", "SSDT", 1, "Sony", "VAIO", 0x20120517)
{
    Device (\_SB.PCI0.LPCB.TPM)
    {
        Name (_HID, EisaId ("IFX0102"))
        Name (_CID, EisaId ("PNP0C31"))
        Name (_STR, Unicode ("TPM 1.2 Device"))
        Name (_CRS, ResourceTemplate ()
        {
            Memory32Fixed (ReadOnly,
                0xFED40000,         // Address Base
                0x00005000,         // Address Length
                )
        })
        OperationRegion (SSMI, SystemIO, 0xB2, One)
        Field (SSMI, ByteAcc, NoLock, Preserve)
        {
            SMID,   8
        }

        OperationRegion (TPMS, SystemMemory, 0x9AFBEF98, 0x0000000C)
        Field (TPMS, AnyAcc, NoLock, Preserve)
        {
            TPMM,   8, 
            TPCC,   8, 
            TPLC,   8, 
            TPLR,   32, 
            NOPP,   8, 
            NOPC,   8, 
            NOPM,   8, 
            TPMC,   8, 
            UCTC,   8
        }

        OperationRegion (TPMR, SystemMemory, 0xFED40000, 0x5000)
        Field (TPMR, AnyAcc, NoLock, Preserve)
        {
            ACC0,   8
        }

        Method (_STA, 0, NotSerialized)
        {
            If (LEqual (ACC0, 0xFF))
            {
                Return (Zero)
            }

            Return (0x0F)
        }

        Method (HINF, 3, Serialized)
        {
            Name (_T_0, Zero)
            While (One)
            {
                Store (Arg1, _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (One)
                    {
                        0x01
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        If (LEqual (_STA (), Zero))
                        {
                            Return (Package (0x01)
                            {
                                Zero
                            })
                        }

                        Return (Package (0x02)
                        {
                            One, 
                            Package (0x02)
                            {
                                One, 
                                0x20
                            }
                        })
                    }
                    Else
                    {
                        BreakPoint
                    }
                }

                Break
            }

            Return (Buffer (Zero) {})
        }

        Method (TPPI, 3, Serialized)
        {
            Name (_T_0, Zero)
            While (One)
            {
                Store (Arg1, _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (0x02)
                    {
                        0xFF, 0x01
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        Return ("1.2")
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x02))
                        {
                            CreateByteField (Arg2, Zero, TPC1)
                            Or (TPC1, 0x80, TPCC)
                            Store (0x50, SMID)
                            Return (Zero)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x03))
                            {
                                Name (TCCP, Package (0x02)
                                {
                                    Zero, 
                                    0xFF
                                })
                                Store (TPCC, Index (TCCP, One))
                                Return (TCCP)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x04))
                                {
                                    Return (0x02)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x05))
                                    {
                                        Name (TLCR, Package (0x03)
                                        {
                                            Zero, 
                                            0xFF, 
                                            Ones
                                        })
                                        Store (TPLC, Index (TLCR, One))
                                        Store (TPLR, Index (TLCR, 0x02))
                                        Return (TLCR)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x06))
                                        {
                                            Return (0x03)
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_0, 0x07))
                                            {
                                                Store (DerefOf (Index (Arg2, Zero)), Local0)
                                                Or (Local0, 0x80, TPCC)
                                                Store (0x50, SMID)
                                                Return (Zero)
                                            }
                                            Else
                                            {
                                                If (LEqual (_T_0, 0x08))
                                                {
                                                    Store (DerefOf (Index (Arg2, Zero)), Local0)
                                                    Or (Local0, 0x80, TPMC)
                                                    Store (0x49, SMID)
                                                    Return (UCTC)
                                                }
                                                Else
                                                {
                                                    BreakPoint
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                Break
            }

            Return (One)
        }

        Method (SMOR, 3, Serialized)
        {
            Name (_T_0, Zero)
            While (One)
            {
                Store (Arg1, _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (One)
                    {
                        0x03
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        Store (Index (Arg2, Zero), TPMM)
                        Store (0x48, SMID)
                        Return (Zero)
                    }
                    Else
                    {
                        BreakPoint
                    }
                }

                Break
            }

            Return (One)
        }

        Method (_DSM, 4, NotSerialized)
        {
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xA5, 0x16, 0x8E, 0xCF, 0xE8, 0xC1, 0x25, 0x4E, 
                        /* 0008 */    0xB7, 0x12, 0x4F, 0x54, 0xA9, 0x67, 0x02, 0xC8
                    }))
            {
                Return (HINF (Arg1, Arg2, Arg3))
            }

            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xA6, 0xFA, 0xDD, 0x3D, 0x1B, 0x36, 0xB4, 0x4E, 
                        /* 0008 */    0xA4, 0x24, 0x8D, 0x10, 0x08, 0x9D, 0x16, 0x53
                    }))
            {
                Return (TPPI (Arg1, Arg2, Arg3))
            }

            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xED, 0x54, 0x60, 0x37, 0x13, 0xCC, 0x75, 0x46, 
                        /* 0008 */    0x90, 0x1C, 0x47, 0x56, 0xD7, 0xF2, 0xD4, 0x5D
                    }))
            {
                Return (SMOR (Arg1, Arg2, Arg3))
            }

            Return (Buffer (Zero) {})
        }
    }
}

